(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('@ngx-translate/core'), require('@angular/forms'), require('@angular/platform-browser'), require('ngx-bootstrap/modal'), require('ngx-bootstrap/pagination'), require('ngx-pagination'), require('ngx-bootstrap/datepicker'), require('ngx-bootstrap/accordion'), require('ngx-bootstrap/tooltip'), require('ngx-bootstrap/tabs')) :
	typeof define === 'function' && define.amd ? define('ngx-formbuilder', ['exports', '@angular/core', '@angular/common/http', '@ngx-translate/core', '@angular/forms', '@angular/platform-browser', 'ngx-bootstrap/modal', 'ngx-bootstrap/pagination', 'ngx-pagination', 'ngx-bootstrap/datepicker', 'ngx-bootstrap/accordion', 'ngx-bootstrap/tooltip', 'ngx-bootstrap/tabs'], factory) :
	(factory((global['ngx-formbuilder'] = {}),global.ng.core,global.ng.common.http,global.ngxt,global.ng.forms,global.ng.platformBrowser,global.ngxbm,global.ngxbp,global.ngxp,global.ngxdbp,global.accordion,global.tooltip,global.tabs));
}(this, (function (exports,core,http,core$1,forms,platformBrowser,modal,pagination,ngxPagination,datepicker,accordion,tooltip,tabs) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */
var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}









function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var StorageService = /** @class */ (function () {
    function StorageService() {
        this._storage = {};
        this._inProgress = {};
    }
    StorageService.prototype.get = function (key) {
        return this._storage[key];
    };
    StorageService.prototype.set = function (key, value) {
        this._storage[key] = value;
    };
    StorageService.prototype.remove = function (key) {
        delete this._storage[key];
    };
    StorageService.prototype.removeMatched = function (match) {
        var _this = this;
        Object.keys(this._storage).forEach(function (key) {
            if (key.indexOf(match) !== -1) {
                _this.remove(key);
            }
        });
        Object.keys(this._inProgress).forEach(function (key) {
            if (key.indexOf(match) !== -1) {
                _this.deleteProgress(key);
            }
        });
    };
    StorageService.prototype.clearCache = function () {
        this._inProgress = {};
        this._storage = {};
    };
    StorageService.prototype.getProgress = function (key) {
        return this._inProgress[key];
    };
    StorageService.prototype.deleteProgress = function (key) {
        delete this._inProgress[key];
    };
    StorageService.prototype.setProgress = function (key) {
        this._inProgress[key] = new core.EventEmitter();
    };
    return StorageService;
}());
StorageService.decorators = [
    { type: core.Injectable },
];
StorageService.ctorParameters = function () { return []; };
var FVEnviroment = /** @class */ (function () {
    function FVEnviroment(debug, apiUrl, defaultLanguage, languages, lowerCaseTranslates) {
        this.debug = debug;
        this.apiUrl = apiUrl;
        this.defaultLanguage = defaultLanguage;
        this.languages = languages;
        this.lowerCaseTranslates = lowerCaseTranslates;
    }
    return FVEnviroment;
}());
var ApiResponse = /** @class */ (function () {
    function ApiResponse(data, error) {
        this.data = data;
        this.error = error;
    }
    return ApiResponse;
}());
var ApiService = /** @class */ (function (_super) {
    __extends(ApiService, _super);
    function ApiService(httpClient, enviroment) {
        var _this = _super.call(this) || this;
        _this.httpClient = httpClient;
        _this.enviroment = enviroment;
        return _this;
    }
    ApiService.prototype.get = function (point, args, parameters, options) {
        if (args === void 0) { args = []; }
        if (parameters === void 0) { parameters = {}; }
        if (options === void 0) { options = {}; }
        return this.request.apply(this, __spread(['GET', point, parameters, options, undefined], args));
    };
    ApiService.prototype.delete = function (point, args, parameters, options) {
        if (args === void 0) { args = []; }
        if (parameters === void 0) { parameters = {}; }
        if (options === void 0) { options = {}; }
        return this.request.apply(this, __spread(['DELETE', point, parameters, options, undefined], args));
    };
    ApiService.prototype.options = function (point, args, parameters, options) {
        if (args === void 0) { args = []; }
        if (parameters === void 0) { parameters = {}; }
        if (options === void 0) { options = {}; }
        return this.request.apply(this, __spread(['OPTIONS', point, parameters, options, undefined], args));
    };
    ApiService.prototype.post = function (point, args, parameters, body, options) {
        if (args === void 0) { args = []; }
        if (parameters === void 0) { parameters = {}; }
        if (body === void 0) { body = {}; }
        if (options === void 0) { options = {}; }
        return this.request.apply(this, __spread(['POST', point, parameters, options, body], args));
    };
    ApiService.prototype.patch = function (point, args, parameters, body, options) {
        if (args === void 0) { args = []; }
        if (parameters === void 0) { parameters = {}; }
        if (body === void 0) { body = {}; }
        if (options === void 0) { options = {}; }
        return this.request.apply(this, __spread(['PATCH', point, parameters, options, body], args));
    };
    ApiService.prototype.put = function (point, args, parameters, body, options) {
        if (args === void 0) { args = []; }
        if (parameters === void 0) { parameters = {}; }
        if (body === void 0) { body = {}; }
        if (options === void 0) { options = {}; }
        return this.request.apply(this, __spread(['PUT', point, parameters, options, body], args));
    };
    ApiService.prototype.getURL = function (point, args, parameters, body, options) {
        if (args === void 0) { args = []; }
        if (parameters === void 0) { parameters = {}; }
        if (body === void 0) { body = {}; }
        if (options === void 0) { options = {}; }
        return this.request.apply(this, __spread(['getURL', point, parameters, options, body], args));
    };
    Object.defineProperty(ApiService.prototype, "apiRenameList", {
        get: function () {
            return ['Name', 'Title'];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ApiService.prototype, "API", {
        get: function () {
            return this.enviroment.apiUrl;
        },
        enumerable: true,
        configurable: true
    });
    ApiService.prototype.rename = function (origin, target) {
        this.languages.forEach(function (lang) {
            var from = origin + "_" + lang;
            var to = "" + origin;
            if (target.hasOwnProperty(from) && !target.hasOwnProperty(to)) {
                target[to] = target[from];
                delete target[from];
            }
        });
    };
    ApiService.prototype.subscribeToPromise = function (subscription) {
        return new Promise(function (resolve, reject) {
            subscription.subscribe(resolve, reject);
        });
    };
    ApiService.prototype.generateUrl = function (url, parameters) {
        var _this = this;
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        var endUrl = "" + url + (args.length ? "/" + args.join('/') : '');
        var queryParams = Object.keys(parameters).map(function (key) { return key + "=" + _this.sanitize(parameters[key]); }).join('&');
        return "" + endUrl + (queryParams ? "?" + queryParams : '');
    };
    ApiService.prototype.sanitize = function (value) {
        var exists = value !== undefined && value !== null;
        var isNum = function (val) { return val.constructor === Number; };
        var isString = function (val) { return val.constructor === String; };
        if (!exists) {
            return value;
        }
        if (isString(value)) {
            return value.trim();
        }
        if (isNum(value)) {
            return value;
        }
        return JSON.stringify(value);
    };
    ApiService.prototype.resolve = function (response) {
        var _this = this;
        if (response && response.data && Array.isArray(response.data)) {
            response.data.forEach(function (item) {
                _this.apiRenameList.forEach(function (renameOrigin) {
                    _this.rename(renameOrigin, item);
                });
            });
        }
        return {
            data: response,
            error: null,
        };
    };
    ApiService.prototype.request = function (method, point, parameters, options, body) {
        var _this = this;
        if (body === void 0) { body = null; }
        var args = [];
        for (var _i = 5; _i < arguments.length; _i++) {
            args[_i - 5] = arguments[_i];
        }
        method = method.toLowerCase();
        var url = this.generateUrl.apply(this, __spread([this.API + point, parameters], args));
        if (method === 'geturl') {
            return url;
        }
        return new Promise(function (resolve, reject) {
            var cache = _super.prototype.get.call(_this, url);
            var progress = _super.prototype.getProgress.call(_this, url);
            var skipCache = options['skipCache'] || false;
            if (cache && skipCache !== true) {
                return resolve(cache);
            }
            else if (progress && skipCache !== true) {
                progress.subscribe(function (response) {
                    _super.prototype.deleteProgress.call(_this, url);
                    var resolvedData = _this.resolve(response);
                    return resolve(resolvedData);
                });
            }
            else {
                var callParameters = [];
                var auth = JSON.parse(localStorage.getItem('auth'));
                var headers = options['headers'] || {};
                if (auth) {
                    headers['Authorization'] = auth.tokenType + " " + auth.token;
                }
                var userContext = JSON.parse(localStorage.getItem('userContext'));
                if (!options['skipRole'] && userContext) {
                    headers['x-Current-Role'] = "" + userContext.role;
                }
                options['headers'] = new http.HttpHeaders(headers);
                if (method === 'get' || method === 'delete' || method === 'options') {
                    callParameters = [url, options];
                    _super.prototype.setProgress.call(_this, url);
                }
                else if (method === 'patch' || method === 'put' || method === 'post') {
                    callParameters = [url, body || {}, options];
                }
                _this.subscribeToPromise((_a = _this.httpClient)[method].apply(_a, __spread(callParameters))).then(function (rawData) {
                    var resolvedData = _this.resolve(rawData);
                    if (method === 'get' || method === 'delete' || method === 'options') {
                        _super.prototype.set.call(_this, url, resolvedData);
                        var prog = _super.prototype.getProgress.call(_this, url);
                        if (prog) {
                            prog.emit(resolvedData);
                            _super.prototype.deleteProgress.call(_this, url);
                        }
                    }
                    return resolve(resolvedData);
                }).catch(function (e) {
                    resolve({ data: null, error: e });
                });
            }
            var _a;
        });
    };
    Object.defineProperty(ApiService.prototype, "languages", {
        get: function () {
            return ['en', 'ro', 'ru'];
        },
        enumerable: true,
        configurable: true
    });
    return ApiService;
}(StorageService));
ApiService.decorators = [
    { type: core.Injectable },
];
ApiService.ctorParameters = function () { return [
    { type: http.HttpClient, },
    { type: FVEnviroment, decorators: [{ type: core.Inject, args: ['enviroment',] },] },
]; };
var Breadcrumbps = /** @class */ (function () {
    function Breadcrumbps(current, path) {
        this.current = current;
        this.path = path;
    }
    return Breadcrumbps;
}());
var ComponentConfig = /** @class */ (function () {
    function ComponentConfig(controls, docketItems, errorMessage, height, isError, items, model, readonly, recordData, title, width, windowMask) {
        this.controls = controls;
        this.docketItems = docketItems;
        this.errorMessage = errorMessage;
        this.height = height;
        this.isError = isError;
        this.items = items;
        this.model = model;
        this.readonly = readonly;
        this.recordData = recordData;
        this.title = title;
        this.width = width;
        this.windowMask = windowMask;
    }
    return ComponentConfig;
}());
var Control = /** @class */ (function () {
    function Control(bindingSet, handler, isHidden, isReadonly, isDisabled, isRequired, key, onCreateValue, onUpdateValue, referenceName, selectAction, view, controlType, dataSourceType, label, options, showAs, columns, сontrolType, editableGrid, controlName, description, eventJs, content, watermark, controls, placeholder, size, inline, isMultiple) {
        this.bindingSet = bindingSet;
        this.handler = handler;
        this.isHidden = isHidden;
        this.isReadonly = isReadonly;
        this.isDisabled = isDisabled;
        this.isRequired = isRequired;
        this.key = key;
        this.onCreateValue = onCreateValue;
        this.onUpdateValue = onUpdateValue;
        this.referenceName = referenceName;
        this.selectAction = selectAction;
        this.view = view;
        this.controlType = controlType;
        this.dataSourceType = dataSourceType;
        this.label = label;
        this.options = options;
        this.showAs = showAs;
        this.columns = columns;
        this.сontrolType = сontrolType;
        this.editableGrid = editableGrid;
        this.controlName = controlName;
        this.description = description;
        this.eventJs = eventJs;
        this.content = content;
        this.watermark = watermark;
        this.controls = controls;
        this.placeholder = placeholder;
        this.size = size;
        this.inline = inline;
        this.isMultiple = isMultiple;
    }
    return Control;
}());
var ControlType = /** @class */ (function () {
    function ControlType() {
    }
    ControlType.controlType = function (num) {
        var enums = ControlType.EFormElement;
        return Object.keys(enums).find(function (key) { return enums[key] === num; });
    };
    ControlType.controlGroupType = function (num) {
        return ControlType.isInputField(num) && 'input'
            || ControlType.isFormField(num) && 'form'
            || ControlType.isDesignField(num) && 'design'
            || 'undefined';
    };
    ControlType.isInputField = function (num) {
        var controlType = ControlType.controlType(num);
        var inputFields = ControlType.inputFields;
        return inputFields.indexOf(controlType) !== -1;
    };
    ControlType.isFormField = function (num) {
        var controlType = ControlType.controlType(num);
        var formFields = ControlType.formFields;
        return formFields.indexOf(controlType) !== -1;
    };
    ControlType.isDesignField = function (num) {
        var controlType = ControlType.controlType(num);
        var designFields = ControlType.designFields;
        return designFields.indexOf(controlType) !== -1;
    };
    ControlType.isDateType = function (num) {
        var dateInputs = [9, 10, 11];
        return dateInputs.indexOf(num) !== -1;
    };
    return ControlType;
}());
ControlType.inputFields = [
    'TextField',
    'TextBox',
    'TextArea',
    'EmailField',
    'NumberField',
    'MoneyField',
    'PositiveNumber',
    'CheckBox',
    'Toggle',
    'RadioButton',
    'UploadFile',
    'ListField',
    'PickList',
    'Lookup',
    'RadioButtonList',
    'DropDownList',
    'Date',
    'Time',
    'DateTime',
];
ControlType.formFields = [
    'Label',
    'Button',
    'EditableGrid',
    'MenuGrid',
    'ProgressBar',
];
ControlType.designFields = [
    'HiddenField',
    'TableLayout',
    'BootstrapRow',
    'SectionLayout',
    'FlexRow',
    'HtmlContent',
    'FormTab',
    'Form',
    'CustomControl',
];
ControlType.EFormElement = Object.freeze({
    UNDEFINED: 0,
    TextBox: 1,
    TextArea: 2,
    Button: 3,
    CheckBox: 4,
    UploadFile: 5,
    RadioButton: 6,
    RadioButtonList: 7,
    DropDownList: 8,
    Date: 9,
    Time: 10,
    DateTime: 11,
    TableLayout: 13,
    BootstrapRow: 14,
    FlexRow: 15,
    Toggle: 16,
    HiddenField: 50,
    Label: 100,
    TextField: 101,
    ListField: 107,
    PickList: 108,
    Lookup: 109,
    EditableGrid: 114,
    EmailField: 121,
    NumberField: 122,
    MoneyField: 123,
    PositiveNumber: 124,
    HtmlContent: 200,
    CustomControl: 201,
    SectionLayout: 300,
    MenuGrid: 400,
    ProgressBar: 401,
    FormTab: 1000,
    Form: 1001,
});
var Dock = /** @class */ (function () {
    function Dock(dock, items) {
        this.dock = dock;
        this.items = items;
    }
    return Dock;
}());
var DockItem = /** @class */ (function () {
    function DockItem(dialogData, disabled, iconCls, isDblClick, listeners, reference, referenceName, selectionEnable, text, tooltip$$1, btnClass) {
        this.dialogData = dialogData;
        this.disabled = disabled;
        this.iconCls = iconCls;
        this.isDblClick = isDblClick;
        this.listeners = listeners;
        this.reference = reference;
        this.referenceName = referenceName;
        this.selectionEnable = selectionEnable;
        this.text = text;
        this.tooltip = tooltip$$1;
        this.btnClass = btnClass;
    }
    return DockItem;
}());
var Extract = /** @class */ (function () {
    function Extract(table, view) {
        this.table = table;
        this.view = view;
    }
    return Extract;
}());
var Field = /** @class */ (function () {
    function Field(autoLoad, bindingSet, controlType, dbType, description, editableGrid, extract, format, maxValue, minValue, name, options, readOnly, required, size, title, watermark, value, label) {
        this.autoLoad = autoLoad;
        this.bindingSet = bindingSet;
        this.controlType = controlType;
        this.dbType = dbType;
        this.description = description;
        this.editableGrid = editableGrid;
        this.extract = extract;
        this.format = format;
        this.maxValue = maxValue;
        this.minValue = minValue;
        this.name = name;
        this.options = options;
        this.readOnly = readOnly;
        this.required = required;
        this.size = size;
        this.title = title;
        this.watermark = watermark;
        this.value = value;
        this.label = label;
    }
    return Field;
}());
var Item = /** @class */ (function () {
    function Item(tabs$$1, handlers) {
        this.tabs = tabs$$1;
        this.handlers = handlers;
    }
    return Item;
}());
var Model = /** @class */ (function () {
    function Model(autoLoad, entityName, idProperty, fields, proxy) {
        this.autoLoad = autoLoad;
        this.entityName = entityName;
        this.idProperty = idProperty;
        this.fields = fields;
        this.proxy = proxy;
    }
    return Model;
}());
var Path = /** @class */ (function () {
    function Path(key, value) {
        this.key = key;
        this.value = value;
    }
    return Path;
}());
var Proxy = /** @class */ (function () {
    function Proxy(url) {
        this.url = url;
    }
    return Proxy;
}());
var Tab = /** @class */ (function () {
    function Tab(controls, key, label, сontrolType) {
        this.controls = controls;
        this.key = key;
        this.label = label;
        this.сontrolType = сontrolType;
    }
    return Tab;
}());
var Task = /** @class */ (function () {
    function Task(breadcrumbps, clientComponent, componentConfig, dockedItems, processInstanceId, processName, stateId, status, taskId, componentClassName) {
        this.breadcrumbps = breadcrumbps;
        this.clientComponent = clientComponent;
        this.componentConfig = componentConfig;
        this.dockedItems = dockedItems;
        this.processInstanceId = processInstanceId;
        this.processName = processName;
        this.stateId = stateId;
        this.status = status;
        this.taskId = taskId;
        this.componentClassName = componentClassName;
    }
    return Task;
}());
Task.TASK_DONE_STATUS = 1;
var FVDoneResponse = /** @class */ (function () {
    function FVDoneResponse(done, close, data, action, group) {
        this.done = done;
        this.close = close;
        this.data = data;
        this.action = action;
        this.group = group;
    }
    return FVDoneResponse;
}());
var GridColumn = /** @class */ (function () {
    function GridColumn(align, dataIndex, flex, hidden, text, type, width) {
        this.align = align;
        this.dataIndex = dataIndex;
        this.flex = flex;
        this.hidden = hidden;
        this.text = text;
        this.type = type;
        this.width = width;
    }
    return GridColumn;
}());
var Store = /** @class */ (function () {
    function Store(autoLoad, formFilter, passColumns, proxy, remoteFilter, remoteSort, title) {
        this.autoLoad = autoLoad;
        this.formFilter = formFilter;
        this.passColumns = passColumns;
        this.proxy = proxy;
        this.remoteFilter = remoteFilter;
        this.remoteSort = remoteSort;
        this.title = title;
    }
    return Store;
}());
var GridComponentConfig = /** @class */ (function () {
    function GridComponentConfig(columns, store, dockedItems, idFilterProperty, model, predefinedFilter, title, editHandlers) {
        this.columns = columns;
        this.store = store;
        this.dockedItems = dockedItems;
        this.idFilterProperty = idFilterProperty;
        this.model = model;
        this.predefinedFilter = predefinedFilter;
        this.title = title;
        this.editHandlers = editHandlers;
    }
    return GridComponentConfig;
}());
var EditHandlers = /** @class */ (function () {
    function EditHandlers(autoNewRow, allowInlineEdit, addAction, deleteAction, editAction, selectActionRo) {
        this.autoNewRow = autoNewRow;
        this.allowInlineEdit = allowInlineEdit;
        this.addAction = addAction;
        this.deleteAction = deleteAction;
        this.editAction = editAction;
        this.selectActionRo = selectActionRo;
    }
    return EditHandlers;
}());
var GridConfig = /** @class */ (function () {
    function GridConfig(componentClassName, componentConfig, id, filters, parent, model, editable, hideFilter, notClickable, addAction, editAction, deleteAction) {
        this.componentClassName = componentClassName;
        this.componentConfig = componentConfig;
        this.id = id;
        this.filters = filters;
        this.parent = parent;
        this.model = model;
        this.editable = editable;
        this.hideFilter = hideFilter;
        this.notClickable = notClickable;
        this.addAction = addAction;
        this.editAction = editAction;
        this.deleteAction = deleteAction;
    }
    return GridConfig;
}());
var Lang = /** @class */ (function () {
    function Lang(Name, Code, Icon) {
        if (Icon === void 0) { Icon = 'fa fa-globe'; }
        this.Name = Name;
        this.Code = Code;
        this.Icon = Icon;
    }
    return Lang;
}());
var Menu = /** @class */ (function () {
    function Menu(id, defaultNode, outlookView, title, windowMask, windowMaskTable, level, icon, folders) {
        this.id = id;
        this.defaultNode = defaultNode;
        this.outlookView = outlookView;
        this.title = title;
        this.windowMask = windowMask;
        this.windowMaskTable = windowMaskTable;
        this.level = level;
        this.icon = icon;
        this.folders = folders;
    }
    return Menu;
}());
var Folder = /** @class */ (function () {
    function Folder(type, name, title, icon, showRecordsCount, renderRootFolder, dynamicTreeOptions, count, window, folders, model) {
        this.type = type;
        this.name = name;
        this.title = title;
        this.icon = icon;
        this.showRecordsCount = showRecordsCount;
        this.renderRootFolder = renderRootFolder;
        this.dynamicTreeOptions = dynamicTreeOptions;
        this.count = count;
        this.window = window;
        this.folders = folders;
        this.model = model;
    }
    return Folder;
}());
var LanguageService = /** @class */ (function () {
    function LanguageService(enviroment, translate, apiService) {
        this.enviroment = enviroment;
        this.translate = translate;
        this.apiService = apiService;
        this.languageChanged = new core.EventEmitter();
        this._firstTime = true;
        this._language = this.loadSavedLanguage() || this.defaultLanguage;
        this._translations = {};
        this.defaultLanguage = enviroment.defaultLanguage || new Lang('English', 'en', 'fa fa-flag');
        this._languages = this.enviroment.languages || [];
        this.translate.setDefaultLang(this.defaultLanguage.Code);
    }
    LanguageService.prototype.loadSavedLanguage = function () {
        return JSON.parse(localStorage.getItem('language')) || false;
    };
    LanguageService.prototype.getTranslate = function (key) {
        var _this = this;
        if (key === void 0) { key = ''; }
        return new Promise(function (resolve, reject) {
            _this.translate.get(key.toLowerCase()).subscribe(resolve, reject);
        });
    };
    LanguageService.prototype.addTranslate = function (langCode, transation) {
        this._translations[langCode] = transation;
    };
    Object.defineProperty(LanguageService.prototype, "languages", {
        get: function () {
            return Promise.resolve(this._languages);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LanguageService.prototype, "language", {
        get: function () {
            return this._language;
        },
        set: function (lang) {
            this.setupLanguage(lang);
        },
        enumerable: true,
        configurable: true
    });
    LanguageService.prototype.setupLanguage = function (lang) {
        var _this = this;
        if (!this.language || !this.language.Code) {
            this._language = lang;
        }
        this.translate.use(this.language.Code);
        this.translate.addLangs([this.language.Code]);
        var translation = this._translations[lang.Code];
        var handleTranslation = function (_translation) {
            _this.translate.setTranslation(_this.language.Code, _translation);
            localStorage.setItem('language', JSON.stringify(lang));
            if (lang.Code !== _this._language.Code) {
                _this._language = lang;
                _this.languageChanged.emit(lang);
            }
        };
        if (translation) {
            handleTranslation(translation);
            return;
        }
        this.apiService.get('translate', [this.language.Code]).then(function (translations) {
            handleTranslation(translations);
        });
    };
    return LanguageService;
}());
LanguageService.decorators = [
    { type: core.Injectable },
];
LanguageService.ctorParameters = function () { return [
    { type: FVEnviroment, decorators: [{ type: core.Inject, args: ['enviroment',] },] },
    { type: core$1.TranslateService, },
    { type: ApiService, },
]; };
var FVNotificationService = /** @class */ (function () {
    function FVNotificationService() {
        this.notifyEvent = new core.EventEmitter();
    }
    FVNotificationService.prototype.error = function (message, title) {
        this.emit({ type: 'error', message: message, title: title });
    };
    FVNotificationService.prototype.info = function (message, title) {
        this.emit({ type: 'info', message: message, title: title });
    };
    FVNotificationService.prototype.success = function (message, title) {
        this.emit({ type: 'success', message: message, title: title });
    };
    FVNotificationService.prototype.warning = function (message, title) {
        this.emit({ type: 'warning', message: message, title: title });
    };
    FVNotificationService.prototype.subscription = function (cb) {
        return this.notifyEvent.subscribe(cb);
    };
    FVNotificationService.prototype.emit = function (data) {
        this.notifyEvent.emit(data);
    };
    return FVNotificationService;
}());
FVNotificationService.decorators = [
    { type: core.Injectable },
];
var LowerTranslatePipe = /** @class */ (function () {
    function LowerTranslatePipe(translate, _ref) {
        this.translate = translate;
        this._ref = _ref;
        this.translatePipe = new core$1.TranslatePipe(this.translate, this._ref);
    }
    LowerTranslatePipe.prototype.transform = function (value) {
        if (value === void 0) { value = ''; }
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var isString = typeof value === 'string';
        var newValue = value;
        if (isString) {
            newValue = value.toLowerCase() || ' ';
        }
        var translation = (_a = this.translatePipe).transform.apply(_a, __spread([newValue], args));
        if (translation === newValue && isString) {
            return value;
        }
        return translation;
        var _a;
    };
    return LowerTranslatePipe;
}());
LowerTranslatePipe.decorators = [
    { type: core.Pipe, args: [{ name: 'ltranslate', pure: false },] },
];
LowerTranslatePipe.ctorParameters = function () { return [
    { type: core$1.TranslateService, },
    { type: core.ChangeDetectorRef, },
]; };
var FBRendererComponent = /** @class */ (function () {
    function FBRendererComponent() {
    }
    return FBRendererComponent;
}());
FBRendererComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'fv-renderer',
                template: "form builder",
                styles: [""],
            },] },
];
FBRendererComponent.ctorParameters = function () { return []; };
var FormBuilderModule = /** @class */ (function () {
    function FormBuilderModule() {
    }
    FormBuilderModule.forRoot = function (enviroment) {
        return {
            ngModule: FormBuilderModule,
            providers: [
                ApiService,
                StorageService,
                LanguageService,
                FVNotificationService,
                { provide: 'enviroment', useValue: enviroment },
            ],
        };
    };
    return FormBuilderModule;
}());
FormBuilderModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [
                    FBRendererComponent,
                ],
                imports: [
                    datepicker.BsDatepickerModule.forRoot(),
                    pagination.PaginationModule.forRoot(),
                    core$1.TranslateModule.forRoot(),
                    accordion.AccordionModule.forRoot(),
                    tooltip.TooltipModule.forRoot(),
                    modal.ModalModule.forRoot(),
                    tabs.TabsModule.forRoot(),
                    ngxPagination.NgxPaginationModule,
                    platformBrowser.BrowserModule,
                    http.HttpClientModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                ],
                providers: [
                    ApiService,
                    StorageService,
                    LanguageService,
                    FVNotificationService,
                    LowerTranslatePipe,
                ],
                schemas: [core.CUSTOM_ELEMENTS_SCHEMA],
            },] },
];
var Debugger = /** @class */ (function () {
    function Debugger() {
    }
    Debugger.prototype.init = function (enviroment) {
        this.enviroment = enviroment;
        this.showDebug = enviroment.debug;
    };
    Debugger.prototype.log = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        this.action.apply(this, __spread(['log'], messages));
    };
    Debugger.prototype.warn = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        this.action.apply(this, __spread(['warn'], messages));
    };
    Debugger.prototype.error = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        this.action.apply(this, __spread(['error'], messages));
    };
    Debugger.prototype.info = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        this.action.apply(this, __spread(['info'], messages));
    };
    Debugger.prototype.debug = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        this.action.apply(this, __spread(['debug'], messages));
    };
    Debugger.prototype.action = function (method) {
        var messages = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            messages[_i - 1] = arguments[_i];
        }
        if (this.showDebug) {
            console[method].apply(console, __spread(messages));
        }
    };
    return Debugger;
}());

exports.ApiResponse = ApiResponse;
exports.ApiService = ApiService;
exports.FVLanguageService = LanguageService;
exports.FVNotificationService = FVNotificationService;
exports.FormBuilderModule = FormBuilderModule;
exports.Breadcrumbps = Breadcrumbps;
exports.ComponentConfig = ComponentConfig;
exports.Control = Control;
exports.ControlType = ControlType;
exports.Dock = Dock;
exports.DockItem = DockItem;
exports.Extract = Extract;
exports.Field = Field;
exports.Item = Item;
exports.Model = Model;
exports.Path = Path;
exports.Proxy = Proxy;
exports.Tab = Tab;
exports.Task = Task;
exports.FVDoneResponse = FVDoneResponse;
exports.FVEnviroment = FVEnviroment;
exports.GridComponentConfig = GridComponentConfig;
exports.Store = Store;
exports.GridColumn = GridColumn;
exports.EditHandlers = EditHandlers;
exports.GridConfig = GridConfig;
exports.Lang = Lang;
exports.Menu = Menu;
exports.Folder = Folder;
exports.Debugger = Debugger;
exports.ɵe = FBRendererComponent;
exports.ɵd = FVEnviroment;
exports.ɵb = FVEnviroment;
exports.ɵc = Lang;
exports.ɵf = LowerTranslatePipe;
exports.ɵa = StorageService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-formbuilder.umd.js.map
