import { HttpClient } from '@angular/common/http';
import { StorageService } from './storage.service';
import { FVEnviroment } from '../models/enviroment';
export declare class ApiResponse {
    data: {
        count: number;
        data: Object;
    } | any;
    error: any | undefined;
    constructor(data?: {
        count: number;
        data: Object;
    } | any, error?: any | undefined);
}
export declare class ApiService extends StorageService {
    private httpClient;
    private enviroment;
    constructor(httpClient: HttpClient, enviroment: FVEnviroment);
    /**
     * Make GET request to api
     * @param point
     * @param args
     * @param parameters
     * @param options
     */
    get(point: string, args?: string[], parameters?: Object, options?: Object): Promise<any>;
    /**
     * Make DELETE request to api
     * @param point
     * @param args
     * @param parameters
     * @param options
     */
    delete(point: string, args?: string[], parameters?: Object, options?: Object): Promise<any>;
    /**
     * Make OPTIONS request to api
     * @param point
     * @param args
     * @param parameters
     * @param options
     */
    options(point: string, args?: string[], parameters?: Object, options?: Object): Promise<any>;
    /**
     * Make POST request to api
     * @param point
     * @param args
     * @param parameters
     * @param options
     */
    post(point: string, args?: string[], parameters?: Object, body?: object | string, options?: Object): Promise<any>;
    /**
     * Make PATCH request to api
     * @param point
     * @param args
     * @param parameters
     * @param options
     */
    patch(point: string, args?: string[], parameters?: Object, body?: object | string, options?: Object): Promise<any>;
    /**
     * Make PUT request to api
     * @param point
     * @param args
     * @param parameters
     * @param options
     */
    put(point: string, args?: string[], parameters?: Object, body?: object | string, options?: Object): Promise<any>;
    /**
     * Return generated url
     * @param point
     * @param args
     * @param parameters
     * @param body
     * @param options
     */
    getURL(point: string, args?: string[], parameters?: Object, body?: object | string, options?: Object): any;
    readonly apiRenameList: string[];
    readonly API: string;
    private rename(origin, target);
    /**
     * Transform subscription to promise
     * For using same behavior throught whole application
     * @param subscription
     */
    private subscribeToPromise(subscription);
    /**
     * Generates final url from api_url + view + query parameters;
     * @param url
     * @param parameters
     * @param args
     */
    private generateUrl(url, parameters, ...args);
    private sanitize(value);
    /**
     * If data contains fields like Name_ru/Name_ro/Name_en transform it into Name.
     * @param data
     */
    private resolve(response);
    /**
     * Private Abstract request function
     * @param method
     * @param point
     * @param parameters
     * @param options
     * @param args
     */
    private request(method, point, parameters, options, body?, ...args);
    private readonly languages;
}
